//   Copyright 2012 Georg-August-Universität Göttingen, Germany
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.

package de.ugoe.cs.autoquest.plugin.usability2.rules.results;

import java.util.Iterator;

/**
 * <p>
 * TODO comment
 * </p>
 * 
 * @author Konni Hartmann
 */
public class SingleMatchResult extends AbstractResult {

    final IMatch match;
    
    public SingleMatchResult(IMatch task) {
        super(true);
        this.match = task;
    }

    /* (non-Javadoc)
     * @see java.lang.Iterable#iterator()
     */
    @Override
    public Iterator<IMatch> iterator() {
        return new Iterator<IMatch>() {
            boolean first = true;
            
            @Override
            public void remove() {
                throw new UnsupportedOperationException();
            }
            
            @Override
            public IMatch next() {
                return match;
            }
            
            @Override
            public boolean hasNext() {
                if(first) {
                    first = false;
                    return true;
                }

                return false;
            }
        };
    }

}
